---
- name: Configure ESX Hosts
  hosts: esx_hosts
  gather_facts: no
  vars_prompt:
    - name: hashi_vault_token
      prompt: What is your hashicorp password?
  vars:
    vcenter_vars: "{{ lookup('hashi_vault', 'secret=vSphere/data/vcenter token={{ hashi_vault_token}} url=https://vault.rmt validate_certs=False') }}"
    esxi_username: "{{ vcenter_vars['esxi_username'] }}"
    esxi_password: "{{ vcenter_vars['esxi_password'] }}"
    # Define vSwitches
    vswitch:
      - switch_name: General Network
        nics:
          - vmnic0
          - vmnic1
        mtu: 9000
        portgroups:
          - Management: 10
          - Domain: 20
          - Services: 30
          - SEIM: 50
      - switch_name: DMZ Network
        nics:
          - vmnic2
        mtu: 1500
        portgroups:
          - www: 0
      - switch_name: Nas Network
        nics:
          - vmnic4
          - vmnic5
        mtu: 9000
        portgroups:
          - Nas: 40
  tasks:
    - name: Add a ESX Host Networks
      vmware_vswitch:
        hostname: '{{ inventory_hostname }}'
        username: '{{ esxi_username }}'
        password: '{{ esxi_password }}'
        switch: "{{ item.switch_name }}"
        nics: "{{ item.nics }}"
        mtu: "{{ item.mtu }}"
        state: present
        validate_certs: no
      delegate_to: localhost
      loop: "{{ vswitch }}"

    - name: Add a ESX Host Portgroups
      vmware_portgroup:
        hostname: '{{ inventory_hostname }}'
        esxi_hostname: '{{ inventory_hostname }}'
        username: '{{ esxi_username }}'
        password: '{{ esxi_password }}'
        switch: "{{ item.0.switch_name }}"
        portgroup: "{{ ((dict(item.1)).items() | list)[0][0] }}"
        vlan_id: "{{ ((dict(item.1)).items() | list)[0][1] }}"
        state: present
        validate_certs: no
      delegate_to: localhost
      with_subelements:
        - "{{ vswitch }}"
        - portgroups
